=== doc/requirements.txt ===
sphinx>=7.1.2,<8
sphinx-new-tab-link>=0.6.0
sphinx-tabs==3.4.7
furo==2024.8.6
myst-parser>=3.0.1,<=4.0.0
